﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using Telerik.Windows.Controls.GridView;

namespace Background_Cell
{
    public class MergedSlotStyleSelector : StyleSelector
    {
        public override Style SelectStyle(object item, DependencyObject container)
        {
            var info = item as MergedCellInfo;
            var cell = container as GridViewMergedCell;
            var column = cell.DataColumn;
            //var ctx = cell.DataContext as MainViewModel;
            //var vm = ctx.SectionElements.OrderBy(o => o.Sequence).ToArray()[info.VerticalStart];

            var baseStyle = Application.Current.Resources["GridViewMergedCellStyle"] as Style;
            var background = new SolidColorBrush(Telerik.Windows.Controls.FluentPalette.Palette.AccentColor);
            //var foreground = new SolidColorBrush(Telerik.Windows.Controls.FluentPalette.Palette.PrimaryMouseOverColor);
            var foreground = new SolidColorBrush(Colors.Red);
            var style = new Style(typeof(GridViewMergedCell), baseStyle);
            style.Setters.Add(new Setter(GridViewMergedCell.VerticalContentAlignmentProperty, VerticalAlignment.Center));
            style.Setters.Add(new Setter(GridViewMergedCell.HorizontalContentAlignmentProperty, HorizontalAlignment.Right));
            //if (vm.IsRulingSegment)
            {
                style.Setters.Add(new Setter(GridViewMergedCell.BackgroundProperty, background)); //<-- THIS WORKS
                style.Setters.Add(new Setter(GridViewMergedCell.ForegroundProperty, foreground)); //<-- THIS DOES NOT WORK
                style.Setters.Add(new Setter(GridViewMergedCell.FontWeightProperty, FontWeights.Bold)); //<-- THIS WORKS
            }
            return style;
        }
    }
}
